﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WC_GantChartTooltips
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraChart1.ChartType = Infragistics.UltraChart.Shared.Styles.ChartType.GanttChart;
            DataTable ganttData = GetData();

            var labelHash = new Hashtable();
            labelHash.Add("TOOLTIPS", new CustomTooltip(ganttData));

            ultraChart1.LabelHash = labelHash;
            ultraChart1.Tooltips.FormatString = "<TOOLTIPS>";

            ultraChart1.DataSource = ganttData;
            ultraChart1.DataBind();
        }

        private DataTable GetData()
        {
            DataTable table = new DataTable();
            table.Columns.Add("GanttSeries", typeof(string));
            table.Columns.Add("GanttTask", typeof(string));
            table.Columns.Add("GanttStart", typeof(DateTime));
            table.Columns.Add("GanttEnd", typeof(DateTime));
            table.Columns.Add("GanttID", typeof(int));
            table.Columns.Add("GanttLinkTo", typeof(int));
            table.Columns.Add("GanttPercentComplete", typeof(int));
            table.Columns.Add("GanttOwner", typeof(string));
            table.Columns.Add("Tooltip", typeof(string));

            table.Rows.Add(new object[] { "Implement", "Phase 4", DateTime.Now.Date, DateTime.Now.AddDays(15).Date, 9, -1, 0, "David", "David Task 4" });
            table.Rows.Add(new object[] { "Implement", "Phase 3", DateTime.Now.AddDays(8).Date, DateTime.Now.AddDays(10).Date, 9, 1, 0, "David", "David Task 3" });
            table.Rows.Add(new object[] { "Implement", "Phase 2", DateTime.Now.AddDays(5).Date, DateTime.Now.AddDays(7).Date, 7, 8, 25, "David", "David Task 2" });
            table.Rows.Add(new object[] { "Implement", "Phase 1", DateTime.Now.AddDays(1).Date, DateTime.Now.AddDays(5).Date, 6, 7, 100, "David", "David Task 1" });

            table.Rows.Add(new object[] { "Design", "Create Diagram", DateTime.Now.AddDays(12).Date, DateTime.Now.AddDays(26).Date, 5, -1, 33, "Bill", "Bill Task 2" });
            table.Rows.Add(new object[] { "Design", "Outline Plans", DateTime.Now.AddDays(6).Date, DateTime.Now.AddDays(12).Date, 4, 5, 100, "Bill", "Bill Task1" });

            table.Rows.Add(new object[] { "Plan", "Review", DateTime.Now.AddDays(2).Date, DateTime.Now.AddDays(4).Date, 3, 3, 0, "Thomas", "Thomas Task 4" });
            table.Rows.Add(new object[] { "Plan", "Delegate Effort", DateTime.Now.Date, DateTime.Now.AddDays(2).Date, 2, 3, 0, "Thomas", "Thomas Task 3" });
            table.Rows.Add(new object[] { "Plan", "Determine Milestones", DateTime.Now.AddDays(8), DateTime.Now.AddDays(12).Date, 1, -1, 25, "Thomas", "Thomas Task 2" });
            table.Rows.Add(new object[] { "Plan", "Establish Goals", DateTime.Now.Date, DateTime.Now.AddDays(6).Date, 0, 1, 100, "Thomas", "Thomas Task 1" });

            return table;
        }
    }
}
